package se.softstuff.nb.nbtranslate.ide.create;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.ExecutionException;
import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileView;
import org.netbeans.api.progress.ProgressHandle;
import org.netbeans.api.progress.ProgressHandleFactory;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectInformation;
import org.netbeans.api.project.ProjectManager;
import org.netbeans.api.project.ProjectUtils;
import org.netbeans.api.project.ui.OpenProjects;
import org.netbeans.spi.project.SubprojectProvider;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.BeanTreeView;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.NbPreferences;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;
import org.openide.util.lookup.ProxyLookup;

public final class CreateProjectVisualPanel1 extends JPanel implements ExplorerManager.Provider, Lookup.Provider {

    public static final String LAST_LOCATION = "lastLocation";
    
    public static final String PROP_SELECTED_PROJECT = "selectedProjects";
    
    private Set<Project> selectedProjects;
    private Lookup lookup;
    private InstanceContent content;
    private ExplorerManager manager;
    private SourceChildren sources;

    public CreateProjectVisualPanel1() {
        initComponents();

        ((BeanTreeView) projectList).setRootVisible(false);
        selectedProjects = new HashSet<Project>();
        manager = new ExplorerManager();
        ActionMap actionMap = getActionMap();
//        actionMap.put("delete", ExplorerUtils.actionDelete(manager, true)); // NOI18N
        actionMap.put("delete", new DeleteAction()); // NOI18N
        Lookup managerLookup = ExplorerUtils.createLookup(manager, actionMap);
        content = new InstanceContent();
        AbstractLookup abstractLookup = new AbstractLookup(content);

        lookup = new ProxyLookup(managerLookup, abstractLookup);
        sources = new SourceChildren(selectedProjects);
        manager.setRootContext(new AbstractNode(sources));

        new LoadOpenProjects().execute();

    }

    public Set<Project> getSelectedProjects() {
        return selectedProjects;
    }
    
    

    private class DeleteAction extends AbstractAction {

        @Override
        public void actionPerformed(ActionEvent e) {
            removeSelectedProjects();
        }
    }

    private void removeSelectedProjects() {
        Node[] selectedNodes = manager.getSelectedNodes();
        for (Node node : selectedNodes) {
            if (node instanceof SourceProjectNode) {
                Project toDelete = ((SourceProjectNode) node).getProject();
                selectedProjects.remove(toDelete);
            }
        }
        firePropertyChange(PROP_SELECTED_PROJECT, null, -1);
        sources.removeNotify();
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(getClass(), "CreateProjectVisualPanel1.bulletin");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        projectList = new BeanTreeView();
        infoLabel = new javax.swing.JLabel();
        addProjectButton = new javax.swing.JButton();
        removeProjectButton = new javax.swing.JButton();
        subModulesCheckBox = new javax.swing.JCheckBox();

        setName("Form"); // NOI18N

        projectList.setName("projectList"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(infoLabel, org.openide.util.NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.infoLabel.text")); // NOI18N
        infoLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        infoLabel.setName("infoLabel"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(addProjectButton, org.openide.util.NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.addProjectButton.text")); // NOI18N
        addProjectButton.setName("addProjectButton"); // NOI18N
        addProjectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addProjectButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(removeProjectButton, org.openide.util.NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.removeProjectButton.text")); // NOI18N
        removeProjectButton.setName("removeProjectButton"); // NOI18N
        removeProjectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeProjectButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(subModulesCheckBox, NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.subModulesCheckBox.text")); // NOI18N
        subModulesCheckBox.setName("subModulesCheckBox"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(projectList, javax.swing.GroupLayout.PREFERRED_SIZE, 204, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(subModulesCheckBox))
                    .addComponent(infoLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addComponent(addProjectButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(removeProjectButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(infoLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(26, 26, 26)
                        .addComponent(addProjectButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(subModulesCheckBox)
                        .addGap(18, 18, 18)
                        .addComponent(removeProjectButton)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(projectList, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void removeProjectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeProjectButtonActionPerformed
        removeSelectedProjects();
    }//GEN-LAST:event_removeProjectButtonActionPerformed

    private void addProjectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addProjectButtonActionPerformed

        String lastLocation = NbPreferences.forModule(getClass()).get(LAST_LOCATION, ".");
        JFileChooser projectChooser = new JFileChooser();
        projectChooser.setCurrentDirectory(new File(lastLocation));
        projectChooser.setFileFilter(new ProjectFileFilter());
        projectChooser.setFileView(new ProjectFileView());
        projectChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        projectChooser.setMultiSelectionEnabled(true);
        projectChooser.setDialogTitle(NbBundle.getMessage(getClass(), "CreateProjectVisualPanel1.addProjectDialog.title"));
        projectChooser.showOpenDialog(this);
        final File[] projectToBeOpenedFiles = projectChooser.getSelectedFiles();
        if (projectToBeOpenedFiles == null) {
            return;
        }
        String currentDir = projectChooser.getCurrentDirectory().getAbsolutePath();
        NbPreferences.forModule(getClass()).put(LAST_LOCATION, currentDir);

        new GetProjectsFromFiles(projectToBeOpenedFiles).execute();


    }//GEN-LAST:event_addProjectButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addProjectButton;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JScrollPane projectList;
    private javax.swing.JButton removeProjectButton;
    private javax.swing.JCheckBox subModulesCheckBox;
    // End of variables declaration//GEN-END:variables

    @Override
    public ExplorerManager getExplorerManager() {
        return manager;
    }

    @Override
    public Lookup getLookup() {
        return lookup;
    }

    class LoadOpenProjects extends SwingWorker<Project[], Void> {

        @Override
        protected Project[] doInBackground() throws Exception {
            Project[] openProjects = OpenProjects.getDefault().getOpenProjects();
            return openProjects;
        }

        @Override
        protected void done() {
            try {
                Project[] openProjects = get();
                selectedProjects.addAll(Arrays.asList(openProjects));
                firePropertyChange(PROP_SELECTED_PROJECT, null, 1);
                sources.addNotify();
            } catch (InterruptedException ex) {
                Exceptions.printStackTrace(ex);
            } catch (ExecutionException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class GetProjectsFromFiles extends SwingWorker<List<Project>, Void> {

        private File[] projectToBeOpenedFiles;
        private ProgressHandle progress;

        public GetProjectsFromFiles(File[] projectToBeOpenedFiles) {
            this.projectToBeOpenedFiles = projectToBeOpenedFiles;
            progress = ProgressHandleFactory.createHandle(NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.progress.title")); //NOI18N
        }

        @Override
        protected List<Project> doInBackground() throws Exception {
            progress.start();
            List<Project> projects = new ArrayList<Project>();
            for (File projectToBeOpenedFile : projectToBeOpenedFiles) {
                FileObject toFileObject = FileUtil.toFileObject(projectToBeOpenedFile);
                try {
                    Project foundProject = ProjectManager.getDefault().findProject(toFileObject);
                    projects.add(foundProject);;

                    if (subModulesCheckBox.isSelected()) {
                        SubprojectProvider subProvider = foundProject.getLookup().lookup(SubprojectProvider.class);
                        if (subProvider != null) {
                            Set<? extends Project> subprojects = subProvider.getSubprojects();
                            projects.addAll(subprojects);
                        }
                    }
                } catch (IOException ex) {
                    Exceptions.printStackTrace(ex);
                } catch (IllegalArgumentException ex) {
                    Exceptions.printStackTrace(ex);
                }
            }

            return projects;
        }

        @Override
        protected void done() {
            progress.finish();
            try {
                List<Project> projects = get();
                selectedProjects.addAll(projects);
                firePropertyChange(PROP_SELECTED_PROJECT, null, 1);
                sources.addNotify();
            } catch (InterruptedException ex) {
                Exceptions.printStackTrace(ex);
            } catch (ExecutionException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    public static class ProjectFileFilter extends FileFilter {

        @Override
        public boolean accept(File fileToTest) {
            if (fileToTest == null || !fileToTest.isDirectory()) {
                return true;
            }
            try{
                File nomFileToTest = FileUtil.normalizeFile(fileToTest);
                FileObject fileObject = FileUtil.toFileObject(nomFileToTest);
                boolean isProject = ProjectManager.getDefault().isProject(fileObject);
                return isProject;
            } catch(Exception e){
                return false;
            }
        }

        @Override
        public String getDescription() {
            return NbBundle.getMessage(CreateProjectVisualPanel1.class, "CreateProjectVisualPanel1.filefilter.description");
        }
    }

    public static class ProjectFileView extends FileView {

        @Override
        public Icon getIcon(File file) {
            try {
                if (!file.isDirectory()) {
                    return super.getIcon(file);
                }
                FileObject fileObject = FileUtil.toFileObject(file);
                Project project = ProjectManager.getDefault().findProject(fileObject);
                ProjectInformation information = ProjectUtils.getInformation(project);
                return information.getIcon();
            } catch (Exception ex) {
                return super.getIcon(file);
            }

        }
    }
}
